/*
 * cosmetic.c -- stuff that looks neat and goes on the screen &c.
 */

#include <ncurses/curses.h>
#include <stdio.h>
#include <stdlib.h>

#include "lyn.h"

void setup_screen(int ccc)
{
  int i;

/*  attrset(COLOR_PAIR(7));
  clrscr();*/
  for (i=0; i<=LINES; i++)
    dwrite(1,i,15,charstr(COLS,' '));
/*  dwrite(1,1,8,charstr(COLS,LCHAR));*/
  cstr(1,1,8,COLS);
  dwrite(1,2,15,version_string);
  dwrite(COLS-36,2,8,"(c) Copyright 1995-96, Devin Carraway");
/*  dwrite(1,4,8,charstr(24,LCHAR));*/
  cstr(1,4,8,24);
  cwrite(1,5,15,"STATUS |07:: ");
  dwrite(4,7,7,"Current Track:");
  dwrite(4,8,7,"Track Time   :");
  dwrite(4,9,7,"Total Time   :");
  dwrite(4,10,7,"CDROM Volume :");
  dwrite(4,11,7,"Mixer CD Vol.:");
  dwrite(4,12,7,"Source Drive :");
  dwrite(4,13,7,"Drive Mode   :");
  dwrite(4,14,7,"CD Database  :");

  dwrite(6,16,7,"Door Closed");
/*  dwrite(6,16,7,"Door Locked");*/
  dwrite(9,17,7,"Raw Read");
  dwrite(6,18,7,"Cooked Read");
  dwrite(4,19,7,"Write Capable");
  dwrite(6,20,7,"A/V Capable");
  dwrite(6,21,7,"Prefetching");
  dwrite(2,22,7,"Channel Control");
  dwrite(6,23,7,"Redbook/HSG");
  for (i=0; i<8; i++)
    dwrite(18,16+i,8,"[ ]");
/*  dwrite(1,LINES,8,charstr(24,LCHAR));
  dwrite(27,4,8,charstr(24,LCHAR));*/
  cstr(1,LINES,8,24);
  cstr(27,4,8,24);
  if (!ccc)
    draw_menu(0);
  else
    ccc_draw(-1);  
/*  dwrite(27,LINES,8,charstr(24,LCHAR));
  dwrite(61,4,8,charstr(COLS-60,LCHAR));*/
  cstr(27,LINES,8,24);
  cstr(61,4,8,COLS-60);
  dwrite(61,5,15,"TRACK SUMMARY");
  dwrite(64,6,15,"##  Len    Type");
  cwrite(61,7,7,"Total:|11 00:00");
/*  dwrite(61,8,8,charstr(COLS-60,LCHAR));*/
  cstr(61,8,8,COLS-60);
  refresh();
}

void draw_menu(int num)
{
  int i;

  for (i=0; i<LINES-6; i++)
    dwrite(28,5+i,8,charstr(23,32));
  dwrite(27,5,15,"KEYS");
  if (!num) {
    cwrite(34,5,10,"F1 |7: Next Menu");
    cwrite(34,6,10,"F2 |7: Song List");
    cwrite(35,8,10,"P |7: Play/Pause");
    cwrite(35,9,10,"S |7: Stop");
    cwrite(33,10,10, "]|2/|10[ |7: Up/Dn Track");
    cwrite(33,11,10,">|2/|10< |7: Seek");
    cwrite(33,12,10,"1|2-|10F |7: Select Track");
    cwrite(35,13,10,"M |7: Select Mode");
    cwrite(35,15,10,"J |7: Eject");
    cwrite(35,16,10,"K |7: Close Door");
    cwrite(35,17,10,"L |7: Lock Door");
    cwrite(35,19,10,"V |7: Full Volume");
    cwrite(35,20,10,"0 |7: Mute");
    cwrite(33,21,10,"+|2/|10- |7: Adj. Volume");
    cwrite(31,23,10,"Q|2,|10ESC |7: Quit");
  } else if (num==1) {
    cwrite(34,5,10 ,"F1 |7: Prev. Menu");
    cwrite(35,7,10, "} |7: + 5 Tracks");
    cwrite(35,8,10,"{ |7: - 5 Tracks");
    cwrite(33,9,10,"1|2-"); cwrite(35,9,10,"9 |7: Tracks 0-9");
    cwrite(33,10,10,"A|2-|10F |7: Tracks 10-15");
    dwrite(31,11,10,"^G"); dwrite(33,11,2,"-"); cwrite(34,11,10,"^Y |7: Tracks 16-35");
    cwrite(33,13,10,"+|2/|10- |7: Vol. +/- 1");
    cwrite(31,14,10,"Up|2/");
    cwrite(34,14,10,"Dn |7: Vol. +/- 10");
    cwrite(29,15,10,"Shft1|2-"); cwrite(35,15,10,"9 |7: Vol. * 10%");
    cwrite(30,17,10,"Y |7: Edit SongLst");
    cwrite(30,18,10,"W |7: Write dbase");
#ifdef SQL_DBASE
#ifdef SQL_DBASE_SUBMIT
    cwrite(30,19,10,"U |7: Upload to net db");
#endif
    cwrite(30,20,10,"R |7: (Re)read Net db");
    cwrite(30,21,10,"T |7: Read local db");
#endif
    cwrite(30,23,10,"N |7: Debug Info");
  }
  refresh();
}

void report_status(char *str)
{
  static char laststr[256];
  
  if (!strcmp(str,laststr))
    return;
  dwrite(11,5,15,"%-14s",str);
  refresh();
  strcpy(laststr,str);
}

#define ERR_PREF_STR "Error:"

char *cur_err;
int err_expire;

void lperror(char *prefix, int sec)
{
  char *ss;
  
  if (!curses_ready) {
    perror(prefix);
    return;
  }
  ss=(char *)malloc(strlen(prefix)+3+strlen(sys_errlist[errno]));
  if (!ss) {
    perror("malloc");
    return;
  }
  sprintf(ss,"%s: %s",prefix,sys_errlist[errno]);
  report_err(ss,sec);
  free(ss);
}

void report_err(char *str, int sec)
{
  char *ss;
  static char laststr[256];
  static int lastc;
  
  if (!strcmp(str,laststr)) {
    err_expire=time(NULL)+sec;
    return;
  }
  if (cur_err)
    free(cur_err);
  cur_err=(char *)malloc(strlen(str)+5);
  if (!cur_err) {
    perror("malloc");
    return;
  }
  strcpy(cur_err,str);
  if (strlen(cur_err)>COLS-strlen(ERR_PREF_STR)) {
    cur_err[COLS-strlen(ERR_PREF_STR)-4]=0;
    strcat(cur_err,"...");
  }
  dwrite(1,3,12,"%s %s",ERR_PREF_STR,cur_err);
  if (sec<=0)
    err_expire=time(NULL)+86400;
  else 
    err_expire=time(NULL)+sec;
}

int clear_err(void)
{
  if (cur_err)
    free(cur_err);
  err_expire=0;
  dwrite(1,3,12,charstr(COLS,' '));
  return 0;
}

int expire_err(void)
{
  if (!err_expire)
    return 2;
  if (time(NULL)>err_expire) {
    clear_err();
    return 0;
  }
  return 1;
}


void report_topline(int c, char *str)
{
  char *ss;
  static char laststr[256];
  static int lastc;
  
  if (!strcmp(str,laststr) && lastc==c)
    return;
  ss=(char *)malloc(strlen(str)+5);
  strcpy(ss,str);
  if (strlen(ss)>COLS-strlen(version_string)-1) {
    ss[COLS-strlen(version_string)-4]=0;
    strcat(ss,"...");
  }
  if (COLS-strlen(laststr)<=strlen(version_string))
    f_write(1,2,15,version_string);
  f_write(strlen(version_string)+1,2,7,charstr(1+COLS-strlen(version_string),32));
  f_write(1+COLS-strlen(ss),2,c,ss);
  refresh();
  strcpy(laststr,str);
  lastc=c;
  free(ss);
}

void update_topline(void)
{
  char s[160];

  if (IF_LISTMODE_EXT || !thiscd.title[0] || thiscd.title[0]=='<') {
    report_topline(8,copyright_string);
    return;
  }
  if (thiscd.title[0]!='<' && thiscd.title[0]) {
    dwrite(strlen(version_string),2,7,charstr(1+COLS-strlen(version_string),32));
    if (playing)
      sprintf(s,"%s, %s",thiscd.title,thiscd.songtitle[cur_track-1]);
    else
      strcpy(s,thiscd.title);
  } else {
#ifdef DEBUGLEVEL
    strcpy(s,"*** no title");
#endif
  }      
  report_topline(15,s);
}

#define XTERM_TITLE_INTERVAL 1

int update_xtermtitle(int playing, int min, int sec)
{
  static int lastxtline;

  if (lastxtline+XTERM_TITLE_INTERVAL>time(NULL))
    return 1;
  if (strncmp((char *)getenv("TERM"),"xterm",5))
    return 2;
  printf("\033]0;lyn - %s, %s",thiscd.title,thiscd.songtitle[cur_track-1]);
  if (playing)
    printf(" (%02d:%02d)",min,sec);
  printf("\007");
  return 0;
}

#define CHECKMARK 'X'

void show_status(void)
{
  int i;
  char *s="X";
  
  i=cd_status();
  oldstatus=cdrom_data.status;
  mvaddch(16,18,CHECKMARK);
  
  if (!playing) {
    cd_set_track(1);
    report_status("STOPPED");
  } else
    report_status("PLAYING");
  dwrite(19,16,5,(i==1 || i==2)?" ":s);  
  dwrite(19,17,5,".");
  dwrite(19,18,5,s);
  dwrite(19,19,5,".");
  dwrite(19,20,5,s);
  dwrite(19,21,5,".");
  dwrite(19,22,5,".");
  dwrite(19,23,5,".");
  if (ccc) {
    cwrite(35,7,10, "%-3.f|2  %.1f%%  ",(float)((20-bal)/20.)*vol,(float)(((20-bal)/20.)*vol)/2.55);
    cwrite(35,8,10, "%-3.f|2  %.1f%%  ",(float)((bal)/20.)*vol,(float)(((bal)/20.)*vol)/2.55);
    cwrite(36,10,10,"%d/%d ",20-bal,bal);
    cwrite(37,12,10,config.active_cdromdevice);
    cwrite(41,15,10,"%x",cur_index);
    cwrite(41,16,10,"%x",cur_cdmode);
    cwrite(41,17,10,"%x",thiscd.length*75);
    cwrite(41,18,10,"%x",cur_frame);
    cwrite(41,19,10,"%x",cur_pos_abs);
    cwrite(41,20,10,"%x",thiscd.length);
  }
}

void show_mode(void)
{
  char *pm[]={"NORM","TRACK RPT","RANDOM","DISC RPT"};

  dwrite(19,13,13,"%-9.9s",pm[playmode]);
}

void drawvol(void)
{
  drawvol_real(0);
}

void drawvol_force(void)
{
  drawvol_real(1);
}

void drawvol_real(int force)
{
  int cdv=(volume.cdv.left+volume.cdv.right)/2;
  int mv=(volume.mv.left+volume.mv.right)/2;
  static int lastcdv,lastmv;

  if (lastcdv!=cdv || force) {
    if (cdv>0)
      dwrite(19,10,13,"%d%%   ",cdv); 
    else 
      dwrite(19,10,13,"MUTE  ");
    lastcdv=cdv;
  }
  if (lastmv!=mv || force) {
    if (mv>0)
      dwrite(19,11,13,"%d%%   ",mv); 
    else 
      dwrite(19,11,13,"MUTE  ");
    lastmv=mv;
  }
}

void redraw_screen(void)
{
  setup_screen(ccc);
  report_status("RESIZED");
  draw_tracklist();
  highlight_track(1,cur_track);
  drawvol_force();
  refresh();
}

void blank_tracklist(void)
{
  int i;
  
  for (i=0; i<TRACKLIST_SIZE+3; i++)
    dwrite(LISTMODE_LEFTX,
    /*(listmode==_LISTMODE_EXT)?27:61,*/
           7+i,
           8,
           charstr((listmode==_LISTMODE_EXT)?COLS-26:COLS-60,32));
/*  dwrite((listmode==_LISTMODE_EXT)?27:61,7,8,charstr((listmode==_LISTMODE_EXT)?COLS-26:COLS-60,LCHAR));*/
  cstr((listmode==_LISTMODE_EXT)?27:61,7,8,(listmode==_LISTMODE_EXT)?COLS-26:COLS-60);
  if (IF_LISTMODE_EXT) {
    cwrite(27,5,15,"SONGLIST    %-51s","NO DISC");
    dwrite(36,5,7,"::");
  }
  refresh();
}

char *last_token(char delim, char *str)
{
  int i;
  
  for (i=strlen(str); i>0; i--)
    if (str[i]==delim)
      return (str+i+1);
  return str;
}